%{
#include <stdio.h>
#include "test.tab.h"
int linecount=1;
%}
%s quoting
%s inline
%s comment

%%
<inline>[^\}]*      {yylval=strdup(yytext); return TEXT; }
<inline>\}          { BEGIN (INITIAL); return INLINE; }
<quoting>[^\"]*      {yylval=strdup(yytext); return TEXT; }
<quoting>\"          { BEGIN (INITIAL); return QUOTE; }
\/\/                {printf("FOO"); BEGIN (comment); }
<comment>[^\n]*       ;
<comment>\n         BEGIN (INITIAL);
let                  return LET;
in                   return IN;
trans                return TRANS;
declstate            return DECLSTATE;
msgcase              return MESSAGECASE;
if                   return IF;
then                 return THEN;
else                 return ELSE;
fi                   return FI;
esac                 return ESAC;
etats                return ETATS;
init                 return INIT;
\(                   return LPAR;
\)                   return RPAR;
\=\>                 return ARROW;
\:\=                 return EQSET;
\+                   return PLUS;
\*                   return TIMES;
-                    return MINUS;
\<\=                 return LESSEQ;
\>\=                 return GREATEREQ;
\<                   return LESS;
\>                   return GREATER;
\=                   return EQ;
\;                   return SEMICOLON;
\,                   return COMMA;
send                 return SEND;
to                   return TO;
snart                return SNART;
new                  return NEW;
\|\|                 return OR;
&&                   return AND;
\|                   return PIPE;
!                    return BANG;
\"                   { BEGIN (quoting); return QUOTE; }
\{                   { BEGIN (inline); return INLINE; }
[a-zA-Z][a-zA-Z0-9]* {yylval=strdup(yytext); return TEXT; }
[0-9]+               {yylval=strdup(yytext); return NUMBER; }
\n                   linecount++;
[ \t]+                  ;
%%
